Page MenuHomeFreeBSD

powerpc: adjust FreeBSD kernel backward compatibility list
ClosedPublic

Authored by alfredo on Dec 13 2021, 10:07 PM.

Details

Summary

Adjust FreeBSD kernel backward compatibility list

Test Plan

Run "make buildkernel" for the affected targets

Diff Detail

Repository
R10 FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

updated after discussion on IRC

I'd be sorely tempted to commit the style changes separately.
Also, I thought that we broke powerpc bin-compat with ELFv2. if so, all these lists are way too long :)

In D33421#755638, @imp wrote:

Also, I thought that we broke powerpc bin-compat with ELFv2. if so, all these lists are way too long :)

This is about kernel, not userland. While you can't execute binaries built for older releases on newer systems, you can have a new kernel and e.g. old chroot or jail.

Makes sense. In that case, I think this is good

This revision is now accepted and ready to land.Dec 14 2021, 12:11 AM
alfredo edited the summary of this revision. (Show Details)
This revision now requires review to proceed.Dec 14 2021, 9:04 PM

looking better! Thanks for splitting out the style changes.
Just a couple of bits of feedback for comments.

sys/powerpc/conf/GENERIC64LE
69

I'd add a rust version here, as well as adding it to the other config files for which it's relevant

sys/powerpc/conf/MPC85XXSPE
67

Why don't the last two have the /powerpc binaries?

sys/powerpc/conf/MPC85XXSPE
67

MPC85XXSPE (powerpcspe) was introduced by FreeBSD 12 according to arch(7), so originally I'd remove compatibility with 10 and 11.
However, after discussion on powerpc64 IRC channel, we concluded that *FreeBSD/powerpcspe* is able to run any *FreeBSD/powerpc* binary/userland, so COMPAT options should be in sync. I'd like to have something to remember us in the future that compat 6-11 is there for that specific reason, but yeah, text looks misleading.

Should I get rid of text "/powerpc binaries" on all lines and explain the reason as a full line comment before COMPAT_FREEBSD6 instead?

sys/powerpc/conf/MPC85XXSPE
67

Should I get rid of text "/powerpc binaries" on all lines and explain the reason as a full line comment before COMPAT_FREEBSD6 instead?

I think that would be better.

add ports package versions and adjust comments

This revision is now accepted and ready to land.Jan 6 2022, 6:10 PM
pkubaj requested changes to this revision.Jan 24 2022, 10:21 PM

sys/powerpc/conf/MPC85XXSPE also includes COMPAT_43. That should also be removed.

This revision now requires changes to proceed.Jan 24 2022, 10:21 PM

Or maybe not, I can see some ARM configs also have this, along with comment [KEEP THIS!].

This revision is now accepted and ready to land.Mar 7 2022, 2:23 PM